#include "cora_fit.h"

#include <stdlib.h>
#include <stdio.h>

/*  ------------------------ */

int func_gt(double *a, double *b)
{
   if (*a > *b) 
     return TRUE;
   return FALSE;
}

/*  ------------------------ */

int func_lt(double *a, double *b)
{
   if (*a < *b) 
     return TRUE;
   return FALSE;
}

/*  ------------------------ */

int func_ge(double *a, double *b)
{
   if (*a >= *b) 
     return TRUE;
   return FALSE;
}

/*  ------------------------ */

int func_ul(double *a, double *b, double *c)
{
   if (*a >= *b && *a <= *c) 
     return TRUE;
   return FALSE;
}

/*  ------------------------ */
void where(Vector * ret, Vector * x, int (*func)(), double *a, int * count)
{
  int i,n;
  
  n=x->len;
  
  vec_init(ret);
  vec_alloc (ret, n);
  *count = 0;
  for(i=1; i<n; ++i)
    if (TRUE == func (&(x->vec[i]), a))
      {
	ret->vec[*count] = i;
	++(*count);
      }
  
  ret->len = *count;
  
  return;
}

/*  ------------------------ */

void where2(Vector * ret, Vector * x, int (*func)(), 
	    double *a, double *b, int * count)
{
  int i,n;
  
  n=x->len;
  
  vec_init(ret);
  vec_alloc (ret, n);
  *count = 0;
  for(i=1;i<n;++i)
    if (TRUE == func (&(x->vec[i]), a, b))
      {
	ret->vec[*count] = i;
	++(*count);
      }
  ret->len = *count;
  
  return;
}

/*  ------------------------ */

void sel_vals(Vector *ret, Vector *r, Vector *good)
{
  
  int n,n_good,i,j=0;
  
  n=r->len;
  n_good=good->len;

  if(n_good > ret->len)
    {
	fprintf(stderr,"Error: attempt to write beyond vector limits\n");
	fprintf(stderr,"%d  > %d\n",n_good,ret->len);
	exit(8);
    }

  for (i=0;i<n;++i)
   {
    if(i == (int)good->vec[j])
      {
	ret->vec[j]=r->vec[i];
	++j;
	if(j > n_good) 
	 {
	   fprintf(stderr,
	      "* Warning *: truncating vector in sel_vals due to overrun.\n");
	   return;
	 }
       }
    /* fprintf(stderr,"%d %d %d\n",j,i,n_good); */
   }
  
  return;
}

